'use strict'

// Imports
const env = require("../toolbox").env
const utils = require("../toolbox").utils;
const Queue = require("./queue")
const Differencify = require('differencify');
const differencify = new Differencify({ debug: true });

class Browser {

    constructor() {
        this.browser = null
    }

    async execute(queue) {
        if (queue === null || queue === undefined || !(queue instanceof Queue)) {
            throw "Queue is not valid"
        }
        await differencify.launchBrowser(env.config);
        await Promise.all(queue.methods.map(async config => {
            await differencify.init({testName: "domain/" + config.testName})
                .newPage()
                .goto(config.url)
                .setViewPort({ width: config.version.width, height: config.version.height })
                .screenshot()
                .toMatchSnapshot()
                .close()
                .end();
        }))
        await differencify.cleanup();
    }
}

module.exports = Browser